/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Send Page by Email (spbeOverlay.js).
 *
 * The Initial Developer of the Original Code is Weidong Lu.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Weidong Lu <lwd.firefox@gmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function spbe_showDialog(){
	
	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");
	
    if (spbeOptions.getIntPref("opt_directThunderbird") != 1) {
		window.openDialog("chrome://sendpagebyemail/content/spbeDialog.xul","showmore", "chrome, resizable=yes", window);		
	}
	else { // invoke thunderbird or seamonkey directly without showing the dialog
		spbe_directThunderbird(window);
	}
}

function spbe_dialogInit(spbe_win){
	
	window.sizeToContent();
	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");

 	var note_flag = spbeOptions.getIntPref("opt_notification");
	if (note_flag != 1) {
		alert("New Features of Send page by email 0.5.0: \n\n1. Fully integrated with Thunderbird and SeaMonkey. \n2. Send images on the webpage as attachments with the email. \n3. GMAIL SMTP Service Support. \n4. New Options dialog. \n5. Automatically remove predefined words from the subject of the email. \n6. Use firefox password manager to store passwords of email accounts. \n\nBesides sendEmail, Thunderbird, and SeaMonky, Send page by email now supports a new command line email-sending program. Please visit the 'Options' dialog for downloads and corresponding configuration changes.\n\nFor further information please visit the homepage of Send page by email."); 
		
		spbeOptions.setIntPref("opt_notification", 1);
	}

	if (spbeOptions.getIntPref("opt_defaultEmailProgram") == -1) {
			 alert("Please specify the path to at least one email program in the Options dialog.");
			 window.openDialog('chrome://sendpagebyemail/content/spbeOptions.xul', 'showoptions', 'chrome, resizable=yes');
	}

	//initialize the from address field if the mutliple account checkbox is selected
	if (spbeOptions.getIntPref("opt_multipleAccounts") == 1) {
		document.getElementById("sbpe_fromAddress").hidden = false;
		spbe_fromAddressListInit(spbeOptions.getCharPref("opt_emailAccountsList"));
	}

	//initialize three email address fields (TO: CC: and BCC:)
	spbe_addressListInit(document.getElementById("spbe_toMenuItem"), spbeOptions.getCharPref("opt_emailList"), "1");
	spbe_addressListInit(document.getElementById("spbe_ccMenuItem"), spbeOptions.getCharPref("opt_emailList"), "2");
	spbe_addressListInit(document.getElementById("spbe_bccMenuItem"), spbeOptions.getCharPref("opt_emailList"), "3");
		
	//initialize the Subject Field & Content Field
	var subjectField = document.getElementById("spbe_subject");
	var webpageTitle = spbe_replaceTitleWords(spbeOptions.getCharPref("opt_wordList"), spbe_win.document.title);
	subjectField.appendItem(webpageTitle, webpageTitle);
	subjectField.selectedIndex = 0;

	var contentField = document.getElementById("spbe_contentRadioGroup");
	contentField.selectedIndex = 0;// "Entire Webpage" of the radiogroup is selected as default content	
		
	// show the hidden option to ask whether to include weblink or not. 
	if (spbeOptions.getIntPref("opt_askWeblink") == true) {
		var includeWeblink = document.getElementById("spbe_includeWeblink");
		if (spbeOptions.getIntPref("opt_includeWeblinkRadioGroup") == 0)
			includeWeblink.setAttribute("label", "Do not include weblink on the webpage to be sent.");
		else if (spbeOptions.getIntPref("opt_includeWeblinkRadioGroup") == 1) 
			includeWeblink.setAttribute("label", "Include weblink on the webpage to be sent.");
		
		includeWeblink.setAttribute("hidden", false);// show the hidden option.
	}
		
	var selectedtxt = spbe_win.document.commandDispatcher.focusedWindow.getSelection().toString();     
	if (selectedtxt != "") {
		subjectField.appendItem(selectedtxt, selectedtxt);
		contentField.selectedIndex = 1;        
		if (selectedtxt.length < 20){ // if length<20 use selected text as Subject and choose webpage as content 
			subjectField.selectedIndex = 1;
			contentField.selectedIndex = 0;
		}//Otherwise, use the title of the website as Subject and choose selected text content
		
		if (spbeOptions.getIntPref("opt_selectedContentEdit") == 1) {
			document.getElementById("spbe_userContent").value = selectedtxt;
		}
	}
	
	//select the default email program
	//by setting the default email program index
	
	document.getElementById("spbe_emailProgramList").selectedIndex = spbeOptions.getIntPref("opt_defaultEmailProgram"); 

	//initialize the Encoding Field
	var charsetField = document.getElementById("spbe_emailCharset");
	var userCharset = spbeOptions.getCharPref("opt_charset"); 
	var charsetIndex = spbeOptions.getIntPref("opt_charsetIndex"); 
	charsetField.appendItem("Chinese Simplified (GB2312)", "GB18030");
	charsetField.appendItem("Chinese Traditional (Big5)", "Big5");
	charsetField.appendItem("Unicode (UTF-8)", "UTF-8");
	charsetField.appendItem("Western European (ISO-8859-1)", "ISO-8859-1");
	charsetField.appendItem("Always use the encoding of the website", "websiteEncoding");
	
	if (charsetIndex == -1) { 
		charsetField.appendItem(userCharset, userCharset);
		charsetField.selectedIndex = 5;
	}
	else charsetField.selectedIndex = charsetIndex;
	
	//initalize the label field
	spbe_labelListInit(document.getElementById("spbe_frequentLabels"), document.getElementById("spbe_labelMenuItem"), spbeOptions.getCharPref("opt_labelList"));
	
	//set focus on subject field
	subjectField.select();
	subjectField.focus();	
}


function spbe_replaceTitleWords(wordListString, title){

	var stringArray = wordListString.split("|");
	for (var n = 0; n < stringArray.length; n++){

		var str = convertUnicode(stringArray[n], "UTF-8", "UNICODE");
		title = title.replace(str, "");
	}

	return title;
}


function spbe_attachImageDialogInit(spbe_win){

	var j = -1;
	var imageSrcString="";
	var imageCollection = spbe_win.document.commandDispatcher.focusedWindow.document.getElementsByTagName("img");
 	var imageList = document.getElementById("spbe_imageScrollbox");
  	var imageArray = new Array();
  	var checkItem = new Array();
  	var imageItem = new Array();
  	var horizentalNode = new Array();	

	sizeToContent();
  	for (var i = 0; i < imageCollection.length; i++){ 
		if (imageSrcString.indexOf(imageCollection[i].src) == -1) {
			imageArray.push(imageCollection[i]);
			imageSrcString = imageSrcString + imageCollection[i].src;
		}
	}

  	if (imageArray.length > 1) imageArray.sort(compareImageSize); // sort images by size

 	for (var i = 0; i < imageArray.length; i++) {
   		if (i%5 == 0) {
  			j++;
 			horizentalNode[j] = imageList.appendChild(document.createElement("hbox"));				
   			horizentalNode[j].setAttribute("height", "100");
			var selectLineCheckbox = document.createElement("checkbox");
			selectLineCheckbox.setAttribute("label", "Select line");
			selectLineCheckbox.setAttribute("id", "selectLine"+j);
			selectLineCheckbox.setAttribute("oncommand","spbe_checkBoxSelectLine("+j+");");
			horizentalNode[j].appendChild(selectLineCheckbox);
   		}
		checkItem[i] = document.createElement("checkbox");
		checkItem[i].setAttribute("id", "imagebox");
  		horizentalNode[j].appendChild(checkItem[i]);
  		imageItem[i] = document.createElement("image");
  		imageItem[i].setAttribute("src", imageArray[i].src);
 		imageItem[i].setAttribute("height", "100");
 		imageItem[i].setAttribute("width", "100");
   		checkItem[i].appendChild(imageItem[i]);
	}	
}

function compareImageSize (imageA,imageB){
		return imageB.width*imageB.height - imageA.width*imageA.height; // sort in reversed order, the largest size is the first
}

function spbe_attachImage(spbe_dialog){

	var imageName="";

	var checkList = document.getElementsByAttribute("id", "imagebox");

	for (var i = 0; i < checkList.length; i++)
		if (checkList[i].checked == 1){ 
			/*Save images*/
			var imageFile = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("TmpD", Components.interfaces.nsIFile);

			imageFile.append(spbe_getImageName(checkList[i].firstChild.src));

			imageFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
			//retrieve image from cache
 			var persist = makeWebBrowserPersist();

			// Calculate persist flags.
			
			nsIWBP = Components.interfaces.nsIWebBrowserPersist;			
			flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
			persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_FROM_CACHE;

			//Leave it to WebBrowserPersist to discover the encoding type (or lack thereof):

			persist.persistFlags |= nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
			persist.saveURI(makeURI(checkList[i].firstChild.src),null,null,null,null,imageFile);

			//add the path of the images (in temp directory) to the attachment list*/
	
  			var attachmentMenu = spbe_dialog.document.getElementById("spbe_attachment");
			var newNode = spbe_dialog.document.importNode(document.createElement("menuitem"), true);
			var imageItemAttach = attachmentMenu.firstChild.appendChild(newNode);

			imageItemAttach.setAttribute("value", imageFile.path);
			imageItemAttach.setAttribute("label", imageFile.path);

	        var selindex = attachmentMenu.selectedIndex;
  			attachmentMenu.selectedIndex = selindex +1;
		}
}

 function makeWebBrowserPersist()
 {
   const persistContractID = "@mozilla.org/embedding/browser/nsWebBrowserPersist;1";
   const persistIID = Components.interfaces.nsIWebBrowserPersist;
   return Components.classes[persistContractID].createInstance(persistIID);
 }

function makeURI(aURL, aOriginCharset, aBaseURI) {
    var ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
    return ioService.newURI(aURL, aOriginCharset, aBaseURI);
}

function spbe_getImageName(imageSrc){
	var imageName = imageSrc.substring(imageSrc.lastIndexOf("/")+1, imageSrc.length);

	if (imageName.indexOf(".") != -1) {// there is at least one .
		var suffix = imageName.substring(imageName.lastIndexOf(".")+1, imageName.length);

		if (imageName.search(/[\*\?\/:><|]/) != -1) {//image names contain illegal letters such as ?, *, /, etc
			if (suffix.search(/[\*\?\/:><|]/) == -1) // suffix does not contains illegal letters.
				imageName = "spbe_tmpImage." + suffix;
			else imageName = "spbe_alltype.jpg";
		} 
	} else { // there is no .
		if (imageName.search(/[\*\?\/:><|]/) == -1) // image name does not contain illegal letters
			imageName = imageName + ".jpg";
		else // contains illegal letters.
			imagename = "spbe_alltype.jpg";
	} 
	return imageName;
}

function spbe_checkBoxSelectAll(){
	var checkList = document.getElementsByAttribute("id","imagebox");
	for (var i = 0;i<checkList.length;i++)
		checkList[i].checked = 1;
}

function spbe_checkBoxSelectLine(line){
	var checkList = document.getElementsByAttribute("id","imagebox");
	var selectedLine = document.getElementById("selectLine"+line);
	for (var i = line*5;i<(line*5+5);i++)
		if (selectedLine.checked == 1)
			checkList[i].checked = 1; // select line
	    else checkList[i].checked = 0; // unselect line
}

function spbe_fromAddressListInit(menuListString){
	
	var stringArray = menuListString.split("|");
	var fromAddressList = document.getElementById("spbe_fromList");	
	for (var n = 0; n < stringArray.length; n++){
		var strArray = stringArray[n].split("&");
		fromAddressList.appendItem(strArray[0], strArray[0]);// only the source email address field field is needed 
	}
	fromAddressList.selectedIndex = 0;// show the first item as default
}

function spbe_addressListInit( menuList, menuListString, flag ){

	var stringArray = menuListString.split("|");
	var horizontalItem = new Array();
	var horizontalNode = new Array();
    var checkItem = new Array();
	var addressField;
	
	if (flag == "1") {
		addressField = document.getElementById("spbe_toList");
		if (stringArray[0].search(/\w/) != -1) //string is not empty or only spaces.
			addressField.label = stringArray[0] + ";";// if flag is true, set the first item as default
		else addressField.label = "";
	} 

	for (var n = 0; n < stringArray.length; n++){
		if (stringArray[n].search(/\w/) != -1) {
			horizontalItem[n] = document.createElement("hbox");
			horizontalNode[n] = menuList.appendChild(horizontalItem[n]);
			checkItem[n] = document.createElement("checkbox");
			if (stringArray[n].length > 60) checkItem[n].setAttribute("label", stringArray[n].substring(0,57)+"...");
			else checkItem[n].setAttribute("label", stringArray[n]);
			checkItem[n].setAttribute("value", stringArray[n]);
			checkItem[n].setAttribute("maxwidth", "50");
			checkItem[n].setAttribute("width", "50");
			checkItem[n].setAttribute("crop", "start");
			checkItem[n].setAttribute("id", flag+"-"+stringArray[n]);
			checkItem[n].setAttribute("oncommand", "spbe_addToAddressField('"+flag+"', '"+stringArray[n]+"');");
			horizontalNode[n].appendChild(checkItem[n]);
		}
	}
}

function spbe_addToAddressField( flag, checkedTxt ){

	var chkbox = document.getElementById(flag+"-"+checkedTxt);
	var menuItem;
    if (flag == "1") menuItem = document.getElementById("spbe_toList");
    else if (flag == "2") menuItem = document.getElementById("spbe_ccList");
    else if (flag == "3") menuItem = document.getElementById("spbe_bccList");


	var originalValue = menuItem.value;
    // if checked, add the checkedTxt, if unchecked, remove the checkedTxt from subject
	if (chkbox.checked == 1)  { 
		menuItem.label = originalValue + checkedTxt + ";";
		menuItem.value = originalValue + checkedTxt + ";";
	}
	else if (chkbox.checked == 0) { 
		 menuItem.label = originalValue.replace(checkedTxt + ";", "");
		 menuItem.value = originalValue.replace(checkedTxt + ";", "");
	}
}

function spbe_labelListInit(verticalBox, menuList, menuListString){

	var stringArray = menuListString.split("|");
    var checkItem = new Array();
    var horizontalItem = new Array();
	var horizontalNode = new Array();
	
	for (var n = 0; n < stringArray.length; n++){
		if (( n % 3 ) == 0){ //add a hbox in order to put three labels in a row 
			var i = n/3;
			horizontalItem[i] = document.createElement("hbox"); 
			if (i > 1) // add the first two line of labels as frequently used ones
				horizontalNode[i] = menuList.appendChild(horizontalItem[i]);// add label checkbox to menulist
			else horizontalNode[i] = verticalBox.appendChild(horizontalItem[i]);//add frequently used label checkbox to vbox
		}
		if (stringArray[n].search(/\S/) != -1) { // if the field is not empty or only contains spaces
			checkItem[n] = document.createElement("checkbox");
			var str = convertUnicode(stringArray[n], "UTF-8", "UNICODE");
			if (str.length > 15) checkItem[n].setAttribute("label", str.substring(0,14));
			else checkItem[n].setAttribute("label", str);
			checkItem[n].setAttribute("tooltiptext", str);
			checkItem[n].setAttribute("width", "113");
			checkItem[n].setAttribute("maxwidth", "113");
			checkItem[n].setAttribute("id", str);
			checkItem[n].setAttribute("oncommand", "spbe_labelSubject('"+str+"');");
			horizontalNode[i].appendChild(checkItem[n]);
		}
	}
	menuList.parentNode.selectedIndex = 1;
}

function spbe_labelSubject( checkedTxt ){

	var subject = document.getElementById("spbe_subject").value;
	var chkbox = document.getElementById(checkedTxt);
    // if checked, add the checkedTxt, if unchecked, remove the checkedTxt from subject
	if (chkbox.checked == 1) document.getElementById("spbe_subject").value = subject + " - " + checkedTxt;
	else if (chkbox.checked == 0) { 
		 document.getElementById("spbe_subject").value = subject.replace(" - "+ checkedTxt, "");;
	}
}

function spbe_handleAttachment(nodeID, flag){
	// handle attachment according to flag ("add","del","clear")
      var nsIFilePicker = Components.interfaces.nsIFilePicker;
      var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	  var attachmentMenu = document.getElementById(nodeID);
	  var selindex = attachmentMenu.selectedIndex;
      if (flag == "add") {
		  fp.init(window, null, nsIFilePicker.modeOpenMultiple);
		  fp.appendFilters(nsIFilePicker.filterAll);
		  var result = fp.show();
		  var afiles = fp.files;
		  var attachedFile;

		  if (result == nsIFilePicker.returnOK) {

			  while (afiles.hasMoreElements()){
				   attachedFile = afiles.getNext().QueryInterface(Components.interfaces.nsILocalFile);
				   var attachedItem = attachmentMenu.firstChild.appendChild(document.createElement("menuitem"));
				   attachedItem.setAttribute("value", attachedFile.path);
				   attachedItem.setAttribute("label", attachedFile.leafName+" ("+attachedFile.path+")");

				   selindex = selindex +1;
			  }
			  attachmentMenu.selectedIndex = selindex;
		  }
	  }
	  else if (flag == "del") {
		  attachmentMenu.removeItemAt(selindex);
		  if (selindex > 0) attachmentMenu.selectedIndex = selindex - 1;//show the item before deleted one 
		  else { // the deleted item is the first item and thus show only a blank item
			  attachmentMenu.appendItem("",""); 
			  attachmentMenu.selectedIndex = 0;
		  } 
	  }
	  else { // clear all files
		  attachmentMenu.removeAllItems(); 
		  attachmentMenu.appendItem("",""); 
		  attachmentMenu.selectedIndex = 0;
	  }
}

function convertUnicode(str, charsetF, charsetT) {
	var convUnicode = Components.classes['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	var charsetFrom = charsetF.toUpperCase();
	var charsetTo = charsetT.toUpperCase();
    
	if (charsetFrom == charsetTo) return str;
	else {
		if (charsetFrom == "UNICODE") { //convert from unicode to other charset such as "UTF-8", "GB2312"
			convUnicode.charset = charsetTo;
			try {
				str = convUnicode.ConvertFromUnicode(str) + convUnicode.Finish();
				return str;
			} catch (e) {
				alert("Encoding Error:" + e);
				return null;
			}
		}
		else { // convert from other charset to unicode
			if (charsetTo == "UNICODE"){
				convUnicode.charset = charsetFrom;
				try {
					str = convUnicode.ConvertToUnicode(str);
					return str;
				} catch (e){
					alert("Encoding Error:" + e);
					return null;
				}
			}
		}
	}
}

function convertAllRelativeLinks(currentDoc, currenthref){

	var srcURL, hrefURL;

	// convert image links
	var allImages = currentDoc.getElementsByTagName("img");

	for (var i=0;i<allImages.length;i++){
		srcURL = allImages[i].getAttribute("src");
		if (srcURL != ""){
			srcURL = relativeToAbsoluteLink(currenthref, srcURL);
			allImages[i].setAttribute("src", srcURL);
		}	 
	}

	// convert iframe links
	var allIframes = currentDoc.getElementsByTagName("iframe");

	for (var i=0;i<allIframes.length;i++){
		srcURL = allIframes[i].getAttribute("src");
		if (srcURL != ""){
			srcURL = relativeToAbsoluteLink(currenthref, srcURL);
			allIframes[i].setAttribute("src", srcURL);
		}	 
	}

	// convert CSS links
	var allCssLinks = currentDoc.getElementsByTagName("link");
	for (var i=0;i<allCssLinks.length;i++){
		hrefURL = allCssLinks[i].getAttribute("href");
		if (hrefURL != ""){
			hrefURL = relativeToAbsoluteLink(currenthref, hrefURL);
			allCssLinks[i].setAttribute("href", hrefURL);
		}
	}

	// convert URL links
	var allUrlLinks = currentDoc.getElementsByTagName("a");
	for (var i=0;i<allUrlLinks.length;i++){
		hrefURL = allUrlLinks[i].getAttribute("href");
		if (hrefURL != ""){
			hrefURL = relativeToAbsoluteLink(currenthref, hrefURL);
			allUrlLinks[i].setAttribute("href", hrefURL);
		}
	}
}


function relativeToAbsoluteLink(baseURL, relativeURL){

	var absoluteURL;
	var parsedURL = parseBaseURL(baseURL);

	if ((relativeURL == null) || (relativeURL.indexOf("://") != -1) || (relativeURL.indexOf("mailto:") != -1) || (relativeURL.indexOf("javascript:") != -1)){
		return relativeURL;
	}

	if (relativeURL.charAt(0) == "/") { // <img src="/images/image.gif">
		absoluteURL = parsedURL[0] + parsedURL[1] + relativeURL;
		return absoluteURL;
	} 
	else if ((relativeURL.charAt(0) == ".") && (relativeURL.charAt(1) == "/")) {//<img src="./images/image.gif">
		
		absoluteURL = parsedURL[0] + parsedURL[1] + parsedURL[2] + relativeURL.substring(1, relativeURL.length);
		return absoluteURL;
	}
	else if (relativeURL.indexOf("../") != -1) {// <img src="../../images/image.gif">

		var relativeURLArray = relativeURL.split("../");
		var pathArray = parsedURL[2].split("/");
		absoluteURL = parsedURL[0] + parsedURL[1]; //protocol + host, for example http://www.mozilla.org/

		for (var i = 0; i < (pathArray.length - relativeURLArray.length + 1); i++)
			absoluteURL = absoluteURL + pathArray[i] + "/";
		absoluteURL = absoluteURL + relativeURLArray[relativeURLArray.length-1];

		return absoluteURL;
	}
	else {// <img src="images/image.gif">
		absoluteURL = parsedURL[0] + parsedURL[1];
		
		if (parsedURL[2] != null) absoluteURL = absoluteURL + parsedURL[2] + "/"+relativeURL;
		else absoluteURL = absoluteURL + "/" + relativeURL;
		
		return absoluteURL;
	}
}


function parseBaseURL(url){
	
	var parsedURL = new Array(); //0:protocol;1:host;2:path
	var pos = url.indexOf("://");
	var lastpos;
	var temp_url;

	if ( pos != -1) {
		parsedURL[0] = url.substring(0, pos+3);
		temp_url = url.substring(pos+3, url.length);
	    pos = temp_url.indexOf("/");
		lastpos = temp_url.lastIndexOf("/");
		if (pos!= -1) {
			parsedURL[1] = temp_url.substring(0, pos);
			if (pos != lastpos) parsedURL[2] = temp_url.substring(pos, lastpos);
		}	
		else parsedURL[1] = temp_url;
				
	}
    else {
		pos = url.indexOf("/");
        lastpos = url.lastIndexOf("/");
		if ((pos != -1) && (pos < lastpos)) {
				parsedURL[1] = url.substring(0, pos);
				parsedURL[2] = url.substring(pos, lastpos);
			}
		else {
			parsedURL[1] = url;
		}
	}
	return parsedURL;
}

function spbe_directThunderbird( spbe_win){

	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");
	var emailProgramPath;

	if (spbeOptions.getIntPref("opt_defaultEmailProgram") == 1) 
		emailProgramPath = spbeOptions.getCharPref("opt_thunderbirdPath");
	else if (spbeOptions.getIntPref("opt_defaultEmailProgram") == 2)
		emailProgramPath = spbeOptions.getCharPref("opt_seaMonkeyPath");

	var emailApp = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);
	if  (emailProgramPath != "")
		emailApp.initWithPath(emailProgramPath);
	else alert("You haven't specify the correct path Thunderbird/SeaMonkey. \n\nPlease either specify the path in the Options dialog or choose another program which has the correct path.");
	
	var focusedWindow = spbe_win.document.commandDispatcher.focusedWindow;
	var weblink = "<a href='"+focusedWindow.location.href+"' target='_blank'>"+focusedWindow.location.href+"</a>";
	var docCharset = spbe_win._content.document.characterSet;
	if ((docCharset.toUpperCase() == "GB2312")||(docCharset.toUpperCase() == "GBK"))
		docCharset = "GB18030"; // if it is Chinese charset use the extended Chinese Charset GB18030 instead of GB2312 or GBK

	var webpageFile = Components.classes["@mozilla.org/file/directory_service;1"]
		.getService(Components.interfaces.nsIProperties)
		.get("TmpD", Components.interfaces.nsIFile);
	
	/*write the webcontent to the temporary file*/
	webpageFile.append("spbe_tmp.html");
	if (webpageFile.exists()) 
		try {
			webpageFile.remove(false);
		} catch (e){
			//alert(e);
		}
	webpageFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);

	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"] .createInstance(Components.interfaces.nsIFileOutputStream);
    foStream.init(webpageFile, 0x04 | 0x08 | 0x20, 0664, 0);

	convertAllRelativeLinks(focusedWindow.document, focusedWindow.location.href);

	var htmlNode = focusedWindow.document.getElementsByTagName("html");		
	var websrcenc = convertUnicode(htmlNode[0].innerHTML, "UNICODE", docCharset);
	var textToBeSent;

	if (spbeOptions.getIntPref("opt_includeWeblinkRadioGroup") == 1)  
		textToBeSent = "<html> <BR><BR>" + weblink + "<BR><BR>" + websrcenc + "</html>";
	else textToBeSent = "<html>"+ websrcenc + "</html>";
	
	foStream.write(textToBeSent, textToBeSent.length);

	var directContent = spbe_win.document.commandDispatcher.focusedWindow.getSelection().toString();
	directContent = convertUnicode(directContent, "UNICODE", docCharset);
	directContent = stringRecursiveReplace(directContent, '\n', "<br>");	
	var directTitle = spbe_replaceTitleWords(spbeOptions.getCharPref("opt_wordList"), spbe_win.document.title)
	directTitle = convertUnicode(directTitle, "UNICODE", docCharset);

	emailArgs = ['-quiet', '-compose', "subject="+directTitle+",body='"+directContent+"',attachment='file:///"+webpageFile.path.replace(/\\/g, "/")+"'"];

	if (emailApp.exists()) {
		var emailProcess = Components.classes["@mozilla.org/process/util;1"].getService(Components.interfaces.nsIProcess);
		emailProcess.init(emailApp);
		emailProcess.run(false, emailArgs, emailArgs.length);
	}
}

function spbe_sendemail( spbe_win, flag){

	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");
	var emailPrograms = ["mailsend", "thunderbird", "seaMonkey", "sendEmail"];
	var whichEmailProgram = document.getElementById("spbe_emailProgramList").selectedIndex;
	var emailProgramPath = spbeOptions.getCharPref("opt_"+emailPrograms[whichEmailProgram]+"Path");

	var emailApp = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);
	if  (emailProgramPath != "")
		emailApp.initWithPath(emailProgramPath);
	else {
		if ((flag == "send") ||(flag == "directThunderbird")){
			alert("You haven't specify the correct path to " + emailPrograms[whichEmailProgram] + " program. \n\nPlease either specify the path in the Options dialog or choose another program which has the correct path.");
			flag = "false"; //neither "send" nor "preview"
		}
	}
	// obtain the html code and perform encoding convertion
	var docCharset = spbe_win._content.document.characterSet;//get the charset of the website
	var userCharset = document.getElementById("spbe_emailCharset").value; // user defined Encoding for outgoing email
	if ((docCharset.toUpperCase() == "GB2312")||(docCharset.toUpperCase() == "GBK"))
		docCharset = "GB18030"; // if it is Chinese charset use the extended Chinese Charset GB18030 instead of GB2312 or GBK

	var decidedCharset = docCharset;	
	if (userCharset != "websiteEncoding"){
		if ((docCharset != userCharset) && (userCharset != "")&& (flag != "false")){ // flag == false then do not ask for this and do not send email. 
			if ((spbeOptions.getIntPref("opt_alwaysDefaultEncoding") == 1) || (confirm("Your preferred encoding ("+userCharset+") is not compatible with the encoding of the webpage ("+ docCharset +").\n  Press 'OK' for "+userCharset+".\n Press 'Cancel' for "+docCharset+". \n\n Please be aware that email recipients may need to change the encoding of the email in order to read properly.")))
				{
					decidedCharset = userCharset; // if confirm() returns OK, use user defined encoding, otherwise use the encoding of the webpage.
				}
		} 
	}

	var focusedWindow = spbe_win.document.commandDispatcher.focusedWindow;
	var emailTitle = document.getElementById("spbe_subject").value; 
	var	emailSubject = convertUnicode(emailTitle, "UNICODE", decidedCharset);
	var userContent = convertUnicode(document.getElementById("spbe_userContent").value, "UNICODE", decidedCharset);
	userContent = stringRecursiveReplace(userContent, '\n', "<br>"); //convert RET to html code
	var weblink = "<a href='"+focusedWindow.location.href+"' target='_blank'>"+focusedWindow.location.href+"</a>";
	var textToBeSent = "";
	var websrcenc;	
	var radioGroupIndex = document.getElementById("spbe_contentRadioGroup").selectedIndex;
	var webpageFile = Components.classes["@mozilla.org/file/directory_service;1"]
		.getService(Components.interfaces.nsIProperties)
		.get("TmpD", Components.interfaces.nsIFile);

	/*write the webcontent to the temporary file*/
	webpageFile.append("spbe_tmp.html");
	if (webpageFile.exists()) 
		try {
			webpageFile.remove(false);
		} catch (e){
			//alert(e);
		}
	webpageFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);

	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"] .createInstance(Components.interfaces.nsIFileOutputStream);
    foStream.init(webpageFile, 0x04 | 0x08 | 0x20, 0664, 0);
    
	if ( radioGroupIndex == 0 ) { // Send webpage
		convertAllRelativeLinks(focusedWindow.document, focusedWindow.location.href);
		
		var htmlNode = focusedWindow.document.getElementsByTagName("html");		
		websrcenc = convertUnicode(htmlNode[0].innerHTML, "UNICODE", decidedCharset);


		if (((spbeOptions.getIntPref("opt_includeWeblinkRadioGroup") == 0) && (document.getElementById("spbe_includeWeblink").checked == false)) || ((spbeOptions.getIntPref("opt_includeWeblinkRadioGroup") == 1) && (document.getElementById("spbe_includeWeblink").checked == true)))
				textToBeSent = "<html>"+ userContent + "<BR><BR>" + weblink + "<BR><BR>" + websrcenc + "</html>";
			else textToBeSent = "<html>"+ userContent + websrcenc + "</html>";
				
			foStream.write(textToBeSent, textToBeSent.length);
	}			
	else if (radioGroupIndex == 1) { // Send selected text selected
		textToBeSent = convertUnicode(focusedWindow.getSelection().toString(), "UNICODE", decidedCharset);

		textToBeSent = stringRecursiveReplace(textToBeSent, '\n', "<br>");
			
		if (((spbeOptions.getIntPref("opt_includeWeblinkRadioGroup") == 0) && (document.getElementById("spbe_includeWeblink").checked == false)) || ((spbeOptions.getIntPref("opt_includeWeblinkRadioGroup") == 1) && (document.getElementById("spbe_includeWeblink").checked == true)))
			textToBeSent ="<html>"+ userContent + "<BR><BR>" + weblink + "<BR><BR>" + textToBeSent + "</html>"; // add the link to the webpage where the text is selected.
		else textToBeSent ="<html>"+ userContent + textToBeSent + "</html>"; 	
		
		foStream.write(textToBeSent, textToBeSent.length);
	}
	else {  // Send user content only selected

		textToBeSent = "<html>"+userContent+"</html>";
		foStream.write(textToBeSent, textToBeSent.length);
	}
	
	foStream.close();

	var emailArgs;
	var toAddress = document.getElementById("spbe_toList").value;
 	var ccAddress = document.getElementById("spbe_ccList").value;
 	var bccAddress = document.getElementById("spbe_bccList").value;
    var attachedItems = document.getElementById("spbe_attachment").firstChild.childNodes;

    // command line email program configuration 
	var fromAddress;
	var replyToEmail;
	var smtpServer;
	var smtpPort;
	var smtpUser = "";
	var smtpPass = "";

	if (((whichEmailProgram == 0) || (whichEmailProgram == 3)) && (flag == "send")) { //command line program options
		if (spbeOptions.getIntPref("opt_multipleAccounts") != 1){ // only one account, get the values from preference
			fromAddress = spbeOptions.getCharPref("opt_sourceEmail");
			replyToEmail = spbeOptions.getCharPref("opt_replyToEmail");
			smtpServer = spbeOptions.getCharPref("opt_smtpServer");
			smtpPort = spbeOptions.getIntPref("opt_portNumber");
			smtpUser = spbeOptions.getCharPref("opt_smtpUser");
						
		} else {//multiple accounts get the account from the list.
			
			var emailAccountArray = spbeOptions.getCharPref("opt_emailAccountsList").split("|");
			emailAccountArray = emailAccountArray[document.getElementById("spbe_fromList").selectedIndex].split("&"); 
			fromAddress = emailAccountArray[0];
			replyToEmail = emailAccountArray[1];
			smtpServer = emailAccountArray[2];
			smtpPort = emailAccountArray[3];
			smtpUser = emailAccountArray[4];
		}
		if (smtpUser.search(/\S/) != -1) 
			smtpPass = spbe_getPassword(fromAddress, smtpUser);
	} // end of if //command line program options


	if (flag == "send") {
		// send webpageFile:spbe_tmp.html 
		// put all the arguments to be passed to the external program in an array.
		
		if (whichEmailProgram == 3) {//use sendEmail
			var logFile = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("TmpD", Components.interfaces.nsIFile);
			logFile.append("spbe_log.txt");

			if (logFile.exists()) 
				try {
					logFile.remove(false);
				} catch (e){
					//alert(e);
				}
			logFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);

			emailArgs = ['-f', fromAddress, '-t', document.getElementById("spbe_toList").value, '-cc', document.getElementById("spbe_ccList").value, '-bcc', document.getElementById("spbe_bccList").value, '-s', smtpServer+":"+smtpPort,'-u', emailSubject, '-o', "message-charset="+decidedCharset, '-o', "message-file="+webpageFile.path, '-l', logFile.path, '-q'];
		
			/* **********************add more arguments according to user selections in the options dialog*****************/
		
			if ( replyToEmail.search(/\S/) != -1)
				emailArgs.push('-o', "reply-to="+replyToEmail);

			if ( smtpUser.search(/\S/) != -1) {
				emailArgs.push('-xu', smtpUser);
			}
			if ( smtpPass.search(/\S/) != -1) {
				emailArgs.push('-xp', smtpPass);
			}		
    
			if (attachedItems.length > 0) { // there is at least one attachment
				emailArgs.push('-a');
				for (var i = 0; i < attachedItems.length; i++) {
					if ((attachedItems[i].value != "") && (attachedItems[i].value != undefined)) 
						emailArgs.push(attachedItems[i].value);
				}
			}
			/* *********end of add more arguments according to user selections in the dialog************ */
		} // end of if (whichEmailProgram == 3)
		else if (whichEmailProgram == 0){ //use mailsend
			toAddress = toAddress.replace(/;/g, ",");

			emailArgs = ['-f', fromAddress, '-t', toAddress, '-smtp', smtpServer, '-port', smtpPort, '-starttls', '-sub', emailSubject, '-cs', decidedCharset, '-attach', webpageFile.path+',text/html,i', '-q'];
		
			if (ccAddress.search(/\S/) != -1)  emailArgs.push('-cc', ccAddress.replace(/;/g, ","));
			else emailArgs.push('+cc');
			
			if (bccAddress.search(/\S/) != -1) emailArgs.push('-bc', bccAddress.replace(/;/g, ","));
			else emailArgs.push('+bc');
			
			if ( replyToEmail.search(/\S/) != -1)
				emailArgs.push('-rt', replyToEmail);

			if ( smtpUser.search(/\S/) != -1) {
				emailArgs.push('-auth','-user', smtpUser);
			}
			if ( smtpPass.search(/\S/) != -1) {
				emailArgs.push('-pass', smtpPass);
			}
    
			for (var i = 0; i < attachedItems.length; i++){					
				if ((attachedItems[i].value != "") && (attachedItems[i].value != undefined)) 
					emailArgs.push('-attach', attachedItems[i].value+",a");
			}

		} // end of eles if (whichEmailProgram == 0)
		else if ((whichEmailProgram == 1) || (whichEmailProgram == 2)){//use thunderbird or seamonkey

			emailArgs = ['-quiet', '-compose'];
			var mozillaArgs= "to=" + toAddress.replace(/;/g, ",");

			if (ccAddress.search(/\S/) != -1)  mozillaArgs = mozillaArgs + ",cc=" + ccAddress.replace(/;/g, ",");
			if (bccAddress.search(/\S/) != -1) mozillaArgs = mozillaArgs + ",bcc=" + bccAddress.replace(/;/g, ",");
			mozillaArgs = mozillaArgs + ",subject='"+emailSubject+"'";	
			mozillaArgs = mozillaArgs + ",body="+userContent;
			
			// start to include all the attachments
			mozillaArgs = mozillaArgs + ",attachment='file:///"+webpageFile.path.replace(/\\/g, "/");//all the attachments should be enclosed in a single quote, therefore there is only one ' and the other ' will be added in the end.
							
			for (var i = 0; i < attachedItems.length; i++){					
				if ((attachedItems[i].value != "") && (attachedItems[i].value != undefined)) 
					mozillaArgs = mozillaArgs + ",file:///"+attachedItems[i].value.replace(/\\/g, "/");	
			}

			mozillaArgs = mozillaArgs + "'";//end of including attachments by putting single quote at the end
			//end of including all the attachments
			emailArgs.push(mozillaArgs);
		}

		if (emailApp.exists()) {
			var emailProcess = Components.classes["@mozilla.org/process/util;1"].getService(Components.interfaces.nsIProcess);
			emailProcess.init(emailApp);
			emailProcess.run(false, emailArgs, emailArgs.length);
			
			if (whichEmailProgram == 3) spbe_win.setTimeout("validateSentEmail('" + emailTitle + "',"+"'"+ logFile.leafName +"'," + 1 +");", 3000);
		
		} else { // email Application does not exits. 
			alert("The email program is not found! \n\n Please visit Options dialog to specify the correct location of "+emailPrograms[whichEmailProgram]+".");
		}
	} else if (flag == "preview"){
		window.open("file://"+webpageFile.path);		
	} 
}

function spbe_getPassword(emailAddress, userName){

	var passWord = {value: null};
	var savePassword = {value: false};
	// the host name of the password we are looking for
	var hostName = "chrome://sendpagebyemail/"+emailAddress;
	
	if (Components.classes["@mozilla.org/passwordmanager;1"]) { // Not firefox 3.0 password management
		
		var spbe_passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
		// ask the password manager for an enumerator:
		var spbe_enumerator = spbe_passwordManager.enumerator;
		// step through each password in the password manager until we find the one we want:
		while (spbe_enumerator.hasMoreElements()) {
			try {
				// get an nsIPassword object out of the password manager.
				// This contains the actual password...
				var spbe_passInfo = spbe_enumerator.getNext().QueryInterface(Components.interfaces.nsIPassword);
				if (spbe_passInfo.host == hostName) {
					// found it!
					passWord.value = spbe_passInfo.password;
					break;
				}
			} catch (ex) {
				alert(ex);
			}
		}// end of while
		if (passWord.value == null) { // password not found in the password manager

			var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
			prompts.promptPassword(null, "Enter Password" , "Please enter the password for "+emailAddress+": ", passWord, "Save my password in the Password Manager of Firefox", savePassword);

	   		if (savePassword.value == true)	spbe_passwordManager.addUser(hostName, userName, passWord.value);			
		}
	}
	else if (Components.classes["@mozilla.org/login-manager;1"]) { // Firefox 3.0 Login Management
		var spbe_loginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
		// Find the user for the given parameters
		var spbe_login = spbe_loginManager.findLogins({}, hostName, null, null);
      
		// Find user from returned array of nsILoginInfo objects
		if (spbe_login.length > 0)	{
			passWord.value = spbe_login[0].password;
		}

		if (passWord.value == null){ // password not found in the Login Manager
			var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
				.getService(Components.interfaces.nsIPromptService);
			prompts.promptPassword(null,"Enter Password","Please enter the password for "+emailAddress+": ", passWord, "Save my password in the Login Manager of Firefox", savePassword);

			if (savePassword.value == true)	{
				var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",
															 Components.interfaces.nsILoginInfo,
															 "init");
				try {
					var spbe_loginInfo = new nsLoginInfo(hostName, null, "email authentication", userName, passWord.value, null, null);
					spbe_loginManager.addLogin(spbe_loginInfo);
				}catch (ex){alert(ex);}
			}
		}
	}

	return passWord.value;
}


function getElementsByClassName (spbe_win, cl) {
	var retnode = [];
	var myclass = new RegExp('\\b'+cl+'\\b');
	var elem = spbe_win.document.commandDispatcher.focusedWindow.document.getElementsByTagName('*');
	for (var i = 0; i < elem.length; i++) {
		var classes = elem[i].className;
		if (myclass.test(classes)) retnode.push(elem[i].innerHTML);
	}
	return retnode;
};

function stringRecursiveReplace(string, oldstr, newstr){
	while (string.indexOf(oldstr) != -1){
		string = string.replace(oldstr, newstr);
	}
	return string;
}

function spbe_alertShow(){

	var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                              .getService(Components.interfaces.nsIAlertsService);

	alertsService.showAlertNotification("", "Success", "Email was sent successfully.", 
                                    false, "", null);
}

function validateSentEmail(subject, logFileName, flag){

	var logFile = Components.classes["@mozilla.org/file/directory_service;1"]
		.getService(Components.interfaces.nsIProperties)
		.get("TmpD", Components.interfaces.nsIFile);

	logFile.append(logFileName);

	if (logFile.exists()){
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
			.createInstance(Components.interfaces.nsIScriptableInputStream);
		istream.init(logFile, 0x01, 0444, 0);	
		sstream.init(istream); 
		var logtxt = "";
   		var str = sstream.read(4096);
		
		while (str.length > 0) {
			logtxt += str;
			str = sstream.read(4096);
		}
		sstream.close();
		istream.close();

		if (logtxt.search(/\S/) == -1){
			if (flag == 1)
				setTimeout("validateSentEmail('" + subject + "',"+"'"+logFileName+"'," + 0 +");", 10000);
			else if (flag == 0){
				alert("Failed to send the email with the subject: "+ subject+". \n\n  Error: Unknown."); 
				logFile.remove(false);
			}
		}
		else if (logtxt.indexOf("successfully") != -1) {
			spbe_alertShow(); // email sent successfully and show alerts.
			logFile.remove(false);
		} 
		else if (logtxt.indexOf("ERROR") != -1) { 
			var errindex = logtxt.value.indexOf("ERROR");
			alert("Failed to send the email with the subject: "+ subject+". \n\n Error: "+logtxt.value.substring(errindex, logtxt.value.length+1));
			logFile.remove(false);
		} 
	}
    else {
		if (flag == 0) alert("Attention! Either failed to send the email with the subject: "+ subject+". \n Or the email has attachments which are too large to be sent in a short time. Please check manually! \n\n  Error: Unknown.");
		else setTimeout("validateSentEmail('" + subject + "',"+"'"+logFileName+"'," + 0 +");", 10000); 
	}
}
